
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .586
        INCLUDE    \masm32\macros\timers.asm
        .LIST

SetClpBdTxt PROTO   :DWORD,:DWORD

        .DATA

string  db 'test string'

        .CODE

_main   PROC

        mov     ecx,1 ;00000

loop00: push    ecx

 ; counter_begin 100000,HIGH_PRIORITY_CLASS

        INVOKE  SetClpBdTxt,offset string,sizeof string

 ; counter_end

        pop     ecx
        dec     ecx
        jnz     loop00

        print   ustr$(eax),13,10

        exit

_main   ENDP

;--------------------------------------------------------------------

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SetClpBdTxt PROC lpString:DWORD,dwLength:DWORD

;Set Clipboard Text
;DednDave, 12-2010

;EAX returns:
;  0 success
;  1 SetClipboardData failed
;  2 GlobalAlloc failed
;  3 OpenClipboard failed

        push    0
        call    OpenClipboard
        or      eax,eax
        push    3                            ;return status = 3
        jz      exit_2

        mov     eax,[esp+12]                 ;dwLength
        pop     edx
        add     eax,16
        INVOKE  GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,eax
        or      eax,eax
        push    2                            ;return status = 2
        jz      exit_1

        pop     edx
        push    eax
        call    EmptyClipboard
        INVOKE  GlobalLock,[esp]
        push    esi
        xchg    eax,edi
        mov     esi,[esp+12]                 ;lpString
        mov     ecx,[esp+16]                 ;dwLength
        rep     movsb
        mov byte ptr [edi],0
        pop     esi
        xchg    eax,edi
        INVOKE  GlobalUnlock,[esp]
        INVOKE  SetClipboardData,CF_TEXT,[esp]
        or      eax,eax
        pop     edx
        jz      exit_3

        push    0                            ;return status = 0

exit_1: call    CloseClipboard

exit_2: pop     eax
        ret     8

exit_3: INVOKE  GlobalFree,edx
        push    1                            ;return status = 1
        jmp     exit_1

SetClpBdTxt ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------

        END     _main

